//--------------------------------------------------------------
// Copyright (C) 2003 Patrick Schaumont (schaum@ee.ucla.edu)                   
// University of California at Los Angeles
//                                                                             
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
//                                                                             
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//                                                                             
// You should have received a copy of the GNU Lesser General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA
//
// $Id: arm_itf.h,v 1.3 2004/10/21 23:32:40 schaum Exp $
//----------------------------------------------------------------

#ifndef ARM_ITF_H
#define ARM_ITF_H

#include "ipblock.h"

namespace simulator {
  class arm_simulator;
}

//-- coprocessor interface

class armsimcp : public aipblock {
  int  deviceid;
  bool interfacewritten;
  simulator::arm_simulator *hook;
 public:
  int  requestcounter;
  armsimcp(char *name);
  void setparm(char *_name);
  void run();
  bool checkterminal(int n, char *tname, aipblock::iodir d);
  bool cannotSleepTest();
  bool needsWakeupTest();
  void touch();
};

//-- debug probe

class armsimprobe : public aipblock {
  int   deviceid;
  bool runonce;
  bool  interfacewritten;
  simulator::arm_simulator *hook; 
  aipblock *probedblock;
 public:
  armsimprobe(char *name);
  void setparm(char *_name);
  void run();
  bool checkterminal(int n, char *tname, aipblock::iodir d);
  bool cannotSleepTest();
  bool needsWakeupTest();
  void touch();
};

//-- memory-mapped interface

class armsimsink : public aipblock {
  int   deviceid;
  simulator::arm_simulator *hook; 
public:
  armsimsink(char *name);
  void setparm(char *_name);
  void run();
  bool checkterminal(int n, char *tname, aipblock::iodir d);
  bool cannotSleepTest();
};

class armsimsource : public aipblock {
  int   deviceid;
  bool  interfacewritten;
  simulator::arm_simulator *hook; 
public:
  armsimsource(char *name);
  void setparm(char *_name);
  void run();
  bool checkterminal(int n, char *tname, aipblock::iodir d);
  bool needsWakeupTest();
  bool cannotSleepTest();
  void touch();
};

#endif
