//--------------------------------------------------------------
// Copyright (C) 2003 Patrick Schaumont (schaum@ee.ucla.edu)                   
// University of California at Los Angeles
//                                                                             
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
//                                                                             
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//                                                                             
// You should have received a copy of the GNU Lesser General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA
//
// $Id: ipconfig.cxx,v 1.7 2004/10/21 23:32:40 schaum Exp $
//----------------------------------------------------------------

#include "ipblock.h"
#include "rterror.h"
#include "arm_itf.h"

// ------- ALLOCATOR --------
//
// decode typename and dynamically allocate 
// aipblock-inherited specific block

#define CREATE(S) if (!strcmp(tname, #S)) return new S(instname) 

aipblock * ipblockcreate(char *instname, char *tname) {
  CREATE(ram);
  CREATE(wideram);
  CREATE(ctr32);
  CREATE(gctr32);
  CREATE(tracer);
  CREATE(armsimsource);
  CREATE(armsimsink);
  CREATE(armsimprobe);
  CREATE(armsimcp);
  CREATE(gfmul16);
  CREATE(rand16);
  cerr << "Error: Unknown ipblock type: " << tname << "\n";
  return new aipblock(instname);
}




