//--------------------------------------------------------------
// Copyright (C) 2003 Patrick Schaumont (schaum@ee.ucla.edu)                   
// University of California at Los Angeles
//                                                                             
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
//                                                                             
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//                                                                             
// You should have received a copy of the GNU Lesser General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA
//
// $Id: arm_itf.h,v 1.4 2004/07/21 23:19:37 schaum Exp $
//--------------------------------------------------------------

#ifndef ARM_ITF_H
#define ARM_ITF_H

#include "ipblock.h"

namespace simulator {
  class arm_simulator;
}

class armzillasink : public aipblock {
  simulator::arm_simulator *hook; // simit-arm-1.1
public:
  armzillasink(char *name);
  void setparm(char *_name);
  void run();
  bool checkterminal(int n, char *tname, aipblock::iodir d);
  bool cannotSleepTest();
};

class armzillasource : public aipblock {
  bool  interfacewritten;
  simulator::arm_simulator *hook; // simit-arm-1.1
public:
  armzillasource(char *name);
  void setparm(char *_name);
  void run();
  bool checkterminal(int n, char *tname, aipblock::iodir d);
  bool needsWakeupTest();
  bool cannotSleepTest();
  void touch();
};

class armzillashmem : public aipblock {  
  unsigned size, wl;  
  unsigned firstport;
 public:  
  armzillashmem(char *name);  
  void setparm(char *_name);  
  void run();  
  bool cannotSleepTest();  
  void touch();  
};  

class armzillashmem_writeport : public aipblock {
  aipblock *shmem;
 public:
  armzillashmem_writeport(char *name);  
  void setparm(char *_name);  
  bool checkterminal(int n, char *tname, aipblock::iodir d);
  void run();  
  bool cannotSleepTest();  
};

class armzillashmem_readport : public aipblock {
  aipblock *shmem;
 public:
  armzillashmem_readport(char *name);  
  void setparm(char *_name);  
  bool checkterminal(int n, char *tname, aipblock::iodir d);
  void run();  
  bool cannotSleepTest();    
};


#endif
