//--------------------------------------------------------------
// Copyright (C) 2003 Patrick Schaumont (schaum@ee.ucla.edu)                   
// University of California at Los Angeles
//                                                                             
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
//                                                                             
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//                                                                             
// You should have received a copy of the GNU Lesser General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA
//
// $Id: armzillatick.cxx,v 1.1 2004/07/21 23:19:38 schaum Exp $
//--------------------------------------------------------------

#include "armzillatick.h"
#include "armzilla.h" // holds list of simulators

armzillatick::armzillatick(char *name) : 
  aipblock(name) {
  hook = 0;
}

void armzillatick::setparm(char *_name) {
  char *proc;

  if ((proc = matchparm(_name, "process"))) {
    cerr << "armzillatick: set processor " << proc << "\n";
    int idx = find_proc_index(proc);
    if (idx < 0) {
      cerr << "armzillatick: processor " << proc << " does not exist\n";
      exit(0);
    }
    hook = glbSims[idx];
    return;
  }
}

void armzillatick::run() {
  ioval[0]->assignulong(hook->get_cycle_count());
}

bool armzillatick::checkterminal(int n, char *tname, aipblock::iodir d) {
  switch (n) {
  case 0:
    return (isoutput(d) && isname(tname, "data"));
    break;
  }
  return false;
}

bool armzillatick::cannotSleepTest() {
  return false;
}


