-- Here is a process that reads out data from d_in.txt
-- and ctl.txt, and can driver the inputs of the
-- sorter8 module.
-- To use the text IO functions in VHDL
--   use IEEE.std_logic_textio.all;
--   use std.textio.all;
   
   process
     file f_d_in : text is in "d_in.txt";
    file f_ctl  : text is in "ctl.txt";
    variable l_d_in : line;
    variable l_ctl  : line;
    variable v_d_in : std_logic_vector(7 downto 0);
    variable v_ctl  : std_logic_vector(1 downto 0);
    begin
    wait until RST'event and RST = '1';
    loop
      if (not(endfile(f_d_in))) then
        readline(f_d_in, l_d_in);
        read(l_d_in, v_d_in);
      else
        assert false
          report "End of input on din.txt"
          severity warning;
      end if;
      if (not(endfile(f_ctl))) then
        readline(f_ctl, l_ctl);
        read(l_ctl, v_ctl);
      else
        assert false
          report "End of input on ctl.txt"
          severity warning;
      end if;
      sig_0 <= v_d_in;
      sig_2 <= v_ctl;
      wait until CLK'event and CLK = '1';
    end loop;
   end process;
   
