he sleep mode of the GEZEL simulator (See Section 4.1 on page 32). When the simulator is running, each clock cycle the function cannotSleepTest() is called. This function needs to return true if sleep mode cannot be started. Once the simulator is in sleep mode, the function needsWakeupTest() is called every skipped clock cycle. The function returns true when the GEZEL simulation needs to wake up again. The function touch is used in the context of cosimulation interfaces, to force the next call to needsWakeupTest to return true. To get insight into these different functions, it is best to study one of the cosimulation interfaces of the GEZEL tools. For example, file arm_itf.cxx in armcosim .
Listing 24. shows how to program the runlength encoder as a derived class from the base class aipblock.
A runlength encoder library block for GEZEL
#include "ipblock.h"

class rle : public aipblock {
  int previous_data_value;
  int runlength;
  int maxlen;
public:
  rle(char *name) : aipblock(name) {
    previous_data_value = -1;
    runlength = 0;
    maxlen = 256;
  }
  void run() {
    ioval[1]->assignulong(0);
    ioval[2]->assignulong(0);	
    if (ioval[0]->toulong() == (unsigned) previous_data_value) {
      runlength = runlength + 1;
      if (runlength == maxlen) {
        ioval[1]->assignulong(runlength);
        ioval[2]->assignulong(ioval[0]->toulong());
        runlength = 0;
      }
    } else {
      if (runlength != 0) {
        ioval[1]->assignulong(runlength);
        ioval[2]->assignulong(previous_data_value);	
      }
      runlength = 1;
    }
    previous_data_value = ioval[0]->toulong();
  }
  bool checkterminal(int n, char *tname, aipblock::iodir dir) {
    switch (n) {
    case 0:
      return (isinput(dir) && isname(tname, "data"));
      break;
    case 1:
      return (isoutput(dir) && isname(tname, "tuplenum"));
      break;
    case 2:
      return (isoutput(dir) && isname(tname, "tupledata"));
      break;
    }
    return false;
  }
  void setparm(char *_name) {
    gval *v = make_gval(32,0);
    if (matchparm(_name, "maxlen", *v)) 
      maxlen = v->toulong();
    else
      printf("Error: rke does not recognize parameter %s\n",_name);
  }
  bool cannotSleepTest() {
    return false;
  }
};
