//--------------------------------------------------------------
// Copyright (C) 2003 Patrick Schaumont (schaum@ee.ucla.edu)                   
// University of California at Los Angeles
//                                                                             
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
//                                                                             
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//                                                                             
// You should have received a copy of the GNU Lesser General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA
//
// $Id: rtopt.h,v 1.4 2004/02/10 01:24:51 schaum Exp $
//--------------------------------------------------------------

#ifndef RTOPT_H
#define RTOPT_H

#include <iostream>

#ifndef _MSC_VER
using namespace std;
#endif

#ifdef _MSC_VER
using std::ostream;
#endif

// compile-time flags

// parser index tables
#define PARSERINDEXTABLES

// enable profiling of register activity during simulation
#define RTACTIVITY

// enable profiling of custom mpzcl allocator
#define MPZALLOCACTIVITY

// use operator return-by-ref instead of return-by-value
#define RTOPSBYREF
#define RTVALUECOPY

// use signal definer cache
#define RTSIGDEFCACHE

void gvalactivity_show(ostream &os);
void rtactivity_show(ostream &os);

// runtime flags
extern int glbAllowSimulatorSleep;
extern int glbMPZCustomAllocator;
extern int glbUseGVALINT;
extern int glbRTDebug;

// counters
extern unsigned long glbRTDPEval;
extern unsigned long glbRTActivityEffUpdate;
extern unsigned long glbRTActivityUpdate;
extern unsigned long glbRTNumRegisters;

extern unsigned long glbmpz2gval;
extern unsigned long glbgval2mpz;

extern unsigned long glbRTCycle;

#endif
