//--------------------------------------------------------------
// Copyright (C) 2003 Patrick Schaumont (schaum@ee.ucla.edu)                   
// University of California at Los Angeles
//                                                                             
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
//                                                                             
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//                                                                             
// You should have received a copy of the GNU Lesser General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA
//
// $Id: rttrace.h,v 1.2 2004/01/25 17:48:41 schaum Exp $
//--------------------------------------------------------------

#ifndef RTTRACE_H
#define RTTRACE_H

#include "artsignal.h"
#include <fstream>

class tracerdumper {
  vector<gval *> buffer;
  ofstream os;
  const unsigned vlen; // #values in trace before flush
  unsigned wptr;
 public:
  tracerdumper(char *file);
  ~tracerdumper();
  void addval(gval *v);
  void setwl(int wl);
};


class tracerblock {
  char        *fname;
  artsignal   *sig;
  tracerdumper td;
 public:
  tracerblock(char *_fname, artsignal *_sig);
  bool isdupfile(char *_fname);
  void eval(unsigned long);
};


#endif
