//--------------------------------------------------------------
// Copyright (C) 2003 Patrick Schaumont (schaum@ee.ucla.edu)                   
// University of California at Los Angeles
//                                                                             
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
//                                                                             
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//                                                                             
// You should have received a copy of the GNU Lesser General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA
//
// $Id: vhdterop.h,v 1.1 2004/02/01 03:31:51 schaum Exp $
//--------------------------------------------------------------

#ifndef VHDTEROP_H
#define VHDTEROP_H

#include "vhdop.h"

class vhdterop : public vhdop {
  public:
	enum _optype {sel_op};

  private:
	_optype type;
	vhdvar* left;
	vhdvar* middle;
	vhdvar* right;

	vhdvar* seteq;
	vector<vhdterop *> terlist;
        bool valid;

  public:
	vhdterop(vhdvar* ,vhdvar* ,vhdvar* ,_optype);
	~vhdterop();

	string gettype();
	void addseteq(vhdvar*); 
	void addter(vhdterop*);
	vhdvar* getleft();
	vhdvar* getmiddle();
	vhdvar* getright();
	string getoperator();
	vector<vhdterop *> getteroplist();
	vhdvar* geteq();
	bool isvalid();
	void setvalid();
	void vhdoutop (vhdout*,bool seteqisreg, bool isfsmcmb);
};


#endif
