//--------------------------------------------------------------
// Copyright (C) 2003 Patrick Schaumont (schaum@ee.ucla.edu)                   
// University of California at Los Angeles
//                                                                             
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
//                                                                             
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//                                                                             
// You should have received a copy of the GNU Lesser General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA
//
// $Id: vsupport.cxx,v 1.18 2005/01/18 17:41:46 schaum Exp $
//--------------------------------------------------------------

#include "vsupport.h"
#include "vhdvar.h"
#include "rterror.h"
#include "asymbol.h"

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef HAVE_SSTREAM
#include <sstream>
using std::string;
using std::ostringstream;

typedef ostringstream ostrstr_t;
#else
#include <strstream.h>

typedef ostrstream ostrstr_t;
#endif

//--------------------------------------------------------------
int vgetconstwl (char* str){
  int i = 0;
  int value;
  value = atoi (str);

  if (value == 0) return 0;

  for (i = 0; value > 0; i ++) {
	value = value / 2;
  }
  return i;
}

string vhextostring(char* value){
    ostrstr_t out;
    out<<'"';
    //convert from hex to binary stream   
    for(unsigned int i=2;i<strlen(value);i++) {
       switch(value[i]){
	    case '0': out<<"0000";break;
	    case '1': out<<"0001";break;
	    case '2': out<<"0010";break;
	    case '3': out<<"0011";break;
	    case '4': out<<"0100";break;
	    case '5': out<<"0101";break;
	    case '6': out<<"0110";break;
	    case '7': out<<"0111";break;
	    case '8': out<<"1000";break;
	    case '9': out<<"1001";break;
	    case 'a':
            case 'A': out<<"1010";break;
	    case 'b':
	    case 'B': out<<"1011";break;
	    case 'c':
	    case 'C': out<<"1100";break;
	    case 'd':
	    case 'D': out<<"1101";break;
	    case 'e': 
	    case 'E': out<<"1110";break;
	    case 'f':
	    case 'F': out<<"1111";break;}
    }
    out<<'"';
    return out.str();
}

string vbintostring(char* value){
    ostrstr_t out;
    out<<'"';   
    for(unsigned int i=2;i<strlen(value);i++) 
       out <<value[i];
    out<<'"';
    return out.str();
}

string vintostring(int num){
    ostrstr_t out;
    out<<num;
    return out.str();
}

string vautoname(string base, string name) {
    return (base + "_" + name);
}

int vstringtoInt(const char* num) {
   int result = 0;
   while (*num >= '0' && *num <='9') {
      result = (result * 10) + (*num - '0');
      num++;
   }   
   return result;
}





