//--------------------------------------------------------------
// Copyright (C) 2003 Patrick Schaumont (schaum@ee.ucla.edu)                   
// University of California at Los Angeles
//                                                                             
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
//                                                                             
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//                                                                             
// You should have received a copy of the GNU Lesser General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA
//
// $Id: vtype.cxx,v 1.1.1.1 2003/09/25 00:01:52 schaum Exp $
//--------------------------------------------------------------

#include "vtype.h"

vstdlogic::vstdlogic(int wlen) :
  from(wlen), upto(0) {}

vstdlogic::vstdlogic(int _from, int _upto) :
  from(_from), upto(_upto) {}

void vstdlogic::dump(ostream &os) {
  int max = from > upto ? from : upto;

  if (max > 1) {
    os << "std_logic_vector(" << from;
    if (from > upto)
      os << " downto ";
    else
      os << " upto ";
    os << upto << ")";
  } else {
    os << "std_logic";
  }
}

vcusttyp::vcusttyp(char * _name) : name(_name) {}

void vcusttyp::dump(ostream &os) {
  os << name;
};

