//--------------------------------------------------------------
// Copyright (C) 2003 Patrick Schaumont (schaum@ee.ucla.edu)                   
// University of California at Los Angeles
//                                                                             
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
//                                                                             
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//                                                                             
// You should have received a copy of the GNU Lesser General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA
//
// $Id: vtype.h,v 1.1.1.1 2003/09/25 00:01:52 schaum Exp $
//--------------------------------------------------------------

#ifndef VTYPE_H
#define VTYPE_H

#include <iostream>
using namespace std;

// vhdl signal type
class vtype {
 public:
  vtype() {}
  virtual ~vtype() {}
  virtual void dump(ostream &os) {}
};

// std_logic type
class vstdlogic : public vtype {
  int from;
  int upto;
 public:
  vstdlogic(int wlen);
  vstdlogic(int from, int upto);
  void dump(ostream &os);
};

// enum type
class vcusttyp : public vtype {
  char *name;
 public:
  vcusttyp(char * _name);
  void dump(ostream &os);
};


#endif
