//--------------------------------------------------------------
// (c) 2004 Patrick Schaumont
// University of California at Los Angeles
//                                                                             
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
//                                                                             
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//                                                                             
// You should have received a copy of the GNU Lesser General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA
//
// $Id: i8051_itf.h,v 1.1 2004/09/16 02:26:00 schaum Exp $
//--------------------------------------------------------------

#ifndef i8051_itf
#define i8051_itf

#include "ipblock.h"

void i8051externalwrite(unsigned int a, unsigned char d);

class i8051sink : public aipblock {
  int portaddress;
public:
  i8051sink(char *name);
  ~i8051sink();
  void setparm(char *_name);
  void run();
  bool checkterminal(int n, char *tname, aipblock::iodir d);
  bool cannotSleepTest(); 
};

class i8051source : public aipblock {
  int   portaddress;
  bool  interfacewritten;
public:
  i8051source(char *name);
  ~i8051source();
  void setparm(char *_name);
  void run();
  bool checkterminal(int n, char *tname, aipblock::iodir d);
  bool needsWakeupTest(); 
  bool cannotSleepTest(); 
  void touch();
};


#endif
