#ifndef SYSTEMC_ITF_H
#define SYSTEMC_ITF_H

#include "rtsim.h"
#include "systemc.h"

class systemcsource : public aipblock {
  bool  interfacewritten;
public:
  systemcsource(char *name);
  void setparm (char *_name);
  void run();
  bool checkterminal(int n, char *tname, aipblock::iodir d);
  bool needsWakeupTest();
  bool cannotSleepTest();
  void touch();
};

class systemcsink : public aipblock {
public:
  systemcsink(char *name);
  void setparm (char *_name);
  void run();
  bool checkterminal(int n, char *tname, aipblock::iodir d);
  bool cannotSleepTest();
};

SC_MODULE(gezel_module) {
  rtsimgen *myrtsimgen;
  sc_in <bool> clk;
  SC_HAS_PROCESS(gezel_module);
  gezel_module(sc_module_name scname, char *fdlname);
  void run();
};

SC_MODULE(gezel_inport) {
  sc_in < sc_int<32> > datain;
  systemcsource *gzlmodule;
  SC_HAS_PROCESS(gezel_inport);
  gezel_inport(sc_module_name scname, char *fdlsigname);
  void run();
};

SC_MODULE(gezel_outport) {
  sc_out < sc_int<32> > dataout;
  systemcsink *gzlmodule;
  SC_HAS_PROCESS(gezel_outport);
  gezel_outport(sc_module_name scname, char *fdlsigname);
};

#endif
