//--------------------------------------------------------------
// Copyright (C) 2004 Patrick Schaumont (schaum@ee.ucla.edu)                   
// University of California at Los Angeles
//                                                                             
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
//                                                                             
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//                                                                             
// You should have received a copy of the GNU Lesser General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA
//
// $Id: field.h,v 1.1 2004/03/10 06:28:01 schaum Exp $
//
//--------------------------------------------------------------
#ifndef FIELD_H
#define FIELD_H

#define INIT_FIELD_X 120
#define INIT_FIELD_Y 40

#define MAX_V_X 4
#define MAX_V_Y 4

#define PADDLE_FROM_EDGE 5

#define NO_COLLISION    0
#define COLLISION_UP    1
#define COLLISION_DOWN  2
#define COLLISION_LEFT  4
#define COLLISION_RIGHT 8
#define COLLISION_UP_LEFT      (COLLISION_UP | COLLISION_LEFT)
#define COLLISION_UP_RIGHT     (COLLISION_UP | COLLISION_RIGHT)
#define COLLISION_DOWN_LEFT    (COLLISION_DOWN | COLLISION_LEFT)
#define COLLISION_DOWN_RIGHT   (COLLISION_DOWN | COLLISION_RIGHT)
#define BALL_LOST       16

#define INT2NET(A) ((A < 0)   ? ((-A + 128) & 255) : (A & 255))
#define NET2INT(A) (((A & 255) > 128) ? (int) (128 - (A&255)) : (int) (A&255))

#define REQ 0x80000000
#define SND 0x40000000
#define RCV 0x20000000

extern volatile unsigned int *data_outp  ;
extern volatile unsigned int *data_inp   ;
extern volatile unsigned int *data_outp_2;
extern volatile unsigned int *data_inp_2 ;
extern volatile unsigned int *data_outp_3;
extern volatile unsigned int *data_inp_3 ;

void send_byte(int b);
int  recv_byte();
void send_byte_2(int b);
int  recv_byte_2();
void send_byte_3(int b);
int  recv_byte_3();
int  poll_byte();
int  poll_byte_2();
int  poll_byte_3();

#endif
