//--------------------------------------------------------------
// Copyright (C) 2004 Patrick Schaumont (schaum@ee.ucla.edu)                   
// University of California at Los Angeles
//                                                                             
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
//                                                                             
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//                                                                             
// You should have received a copy of the GNU Lesser General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA
//
// $Id: protocol.c,v 1.1 2004/03/10 06:28:03 schaum Exp $
//
//--------------------------------------------------------------
#include "field.h"


volatile unsigned int *data_outp;
volatile unsigned int *data_inp ;
volatile unsigned int *data_outp_2;
volatile unsigned int *data_inp_2 ;
volatile unsigned int *data_outp_3;
volatile unsigned int *data_inp_3 ;


void send_byte(int b) {
  int k;

  k = INT2NET(b) | REQ;
  *data_outp = k ;
  while ( !(*data_inp & REQ) ) ;
  *data_outp = 0;
  while ( (*data_inp & REQ) ) ;
}

void send_byte_2(int b) {
  int k;

  k = INT2NET(b) | REQ;
  *data_outp_2 = k ;
  while ( !(*data_inp_2 & REQ) ) ;
  *data_outp_2 = 0;
  while ( (*data_inp_2 & REQ) ) ;
}

void send_byte_3(int b) {
  int k;

  k = INT2NET(b) | REQ;
  *data_outp_3 = k ;
  while ( !(*data_inp_3 & REQ) ) ;
  *data_outp_3 = 0;
  while ( (*data_inp_3 & REQ) ) ;
}

int recv_byte() {
  int b;

  while ( !(*data_inp & REQ) ) ;
  b = NET2INT(*data_inp);
  *data_outp = REQ;
  while (  (*data_inp & REQ) ) ;
  *data_outp = 0;
  return b;
}

int recv_byte_2() {
  int b;

  while ( !(*data_inp_2 & REQ) ) ;
  b = NET2INT(*data_inp_2);
  *data_outp_2 = REQ;
  while (  (*data_inp_2 & REQ) ) ;
  *data_outp_2 = 0;
  return b;
}

int recv_byte_3() {
  int b;

  while ( !(*data_inp_3 & REQ) ) ;
  b = NET2INT(*data_inp_3);
  *data_outp_3 = REQ;
  while (  (*data_inp_3 & REQ) ) ;
  *data_outp_3 = 0;
  return b;
}

int poll_byte() {
  return ((*data_inp & REQ) != 0);
}

int poll_byte_2() {
  return ((*data_inp_2 & REQ) != 0);
}

int poll_byte_3() {
  return ((*data_inp_3 & REQ) != 0);
}
