// armzilla shared-memory driver program
// Copyright (c) 2004 Patrick Schaumont
// $Id: cdriver.c,v 1.1 2004/09/16 19:17:24 schaum Exp $

volatile unsigned *m_req     = (unsigned *) 0x80000000;
volatile unsigned *m_ack     = (unsigned *) 0x80000004;
volatile unsigned *m_region0 = (unsigned *) 0x80000040;
volatile unsigned *m_region1 = (unsigned *) 0x80000080;
volatile unsigned *m_region2 = (unsigned *) 0x800000C0;

unsigned last_ack = 0;
unsigned last_req = 0;

#define TOGGLE(A,K) A = (A ^ (1 << K))
#define POLL(A1,A2,K) (A1 & (1 << K)) ^ (A2 & (1 << K))
 
int main() {

  unsigned i, j;


  for (j=0; j < 3; j++) {

    // fill operand memories
    for (i=0; i<16; i++) {
      m_region0[i] = (j+1) * i;
      m_region1[i] = (j+1) * (16-i);
    }

    // request send on region 0 and 1    
    TOGGLE(last_req, 0);
    TOGGLE(last_ack, 0);
    TOGGLE(last_req, 1);
    TOGGLE(last_ack, 1);

    *m_req = last_req;
    
    // read result
    for (i=0; i<16; i++)
      printf("[%d] = %d\n", i, m_region2[i]);
    
    // request read on region 2
    TOGGLE(last_req, 2);
    TOGGLE(last_ack, 2);

    *m_req = last_req;
    
    // signal
    while ( POLL(*m_ack, last_ack, 2)) ;

    while ( ( POLL(*m_ack, last_ack, 0)) &&
	    ( POLL(*m_ack, last_ack, 1))) ;


  }
}

